"""
Tagfu - An Entity Tagging System
Copyright (c) 2006, Alexander Botero-Lowry, Michael Richardson
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  * Neither the name of the authors explicitly named above, the name of the
    Tagfu Team, nor the names of its contributors may be used to endorse or
    promote products derived from this software without specific prior written
    permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from tagfu.tagfu import Tagfu
tf = Tagfu()

def tag_check(tag = None):
	""" A placeholder until we get real exception handling."""
	if tag in tf.tags:
		return 1
	else: 
		return 0

def tag_count(tag = None):
	""" Grab how many ents are associated with a tag; defaults to all. """
	if tag:
		tag_num = tag_check(tag)
		if tag_num == 1:
			print tag, len(tf.entities_with_tag(tag[1]))
		else: 
			print "Sorry, that tag does not exist."
	else: 
		for a in tf.tags:
			print a[1], len(tf.entities_with_tag(a[1]))
					
def tag_ent_list(tag = None):
	""" List ents associated with a tag; defaults to all. """
	if tag:
		tag_num = tag_check(tag)
		if tag_num == 1:
			print "\n" + tag[1] + ":"
			for a in tf.entities_with_tag(tag[1]):
				print a
		else:
			print "That tag does not exist."
	else:
		for a in tf.tags:
			print "\n" + a[1] + ":"
			for a in tf.entities_with_tag(a[1]):
				print a

#Create a dictionary to turn strings into functions.
tag_info = {'count': tag_count, 'ents': tag_ent_list}

print "\nNumber of entities associated with each tag: "
print "===================================================="

tag_info['count']()

print
print
print "Entities for each tag: "
print "===================================================="

tag_info['ents']()
